Dist::Zilla::Plugin::MetaNoIndex(3pm)

NAME
Dist::Zilla::Plugin::MetaNoIndex - Stop CPAN from indexing stuff

VERSION
version 6.037

SYNOPSIS
In your dist.ini:

  [MetaNoIndex]

  directory = t/author
  directory = examples

  file = lib/Foo.pm

  package = My::Module

  namespace = My::Module

DESCRIPTION
This plugin allows you to prevent PAUSE/CPAN from indexing files you don't want indexed. This is useful if you build test classes or example classes that are used for those purposes only, and are not part of the distribution. It does this by adding a "no_index" block to your META.json (or META.yml) file in your distribution.

PERL VERSION
This module should work on any version of perl still receiving updates from the Perl 5 Porters. This means it should work on any version of perl released in the last two to three years. (That is, if the most recently released version is v5.40, then this module should work on both v5.40 and v5.38.)

Although it may work on older versions of perl, no guarantee is made that the minimum required version will not be increased. The version may be increased for any reason, and there is no promise that patches will be accepted to lower the minimum required perl.

ATTRIBUTES

  directories
Exclude folders and everything in them, for example: author.t

Aliases: "folder", "dir", "directory"

  files
Exclude a specific file, for example: lib/Foo.pm

Alias: "file"

  packages
Exclude by package name, for example: "My::Package"

Aliases: "class", "module", "package"

  namespaces
Exclude everything under a specific namespace, for example: "My::Package"

Alias: "namespace"

NOTE: This will not exclude the package "My::Package", only everything under it like "My::Package::Foo".

METHODS

  metadata
Returns a reference to a hash containing the distribution's no_index metadata.

SEE ALSO
Dist::Zilla roles: MetaProvider.

AUTHOR
Ricardo SIGNES 😏 <cpan@semiotic.systems>

COPYRIGHT AND LICENSE
This software is copyright (c) 2026 by Ricardo SIGNES.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.